VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DUKE"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private DX As New DirectX8
Private D3D As Direct3D8
Private D3DDevice As Direct3DDevice8
Private D3DParam As D3DPRESENT_PARAMETERS
Private DispMode As D3DDISPLAYMODE
Private D3DX As New D3DX8
Private ResoX As Long, ResoY As Long, Handler As Long
Public DUKE_Running As Boolean
Public Afficher_FPS As Boolean
Private Const D3DFVF = D3DFVF_XYZRHW Or D3DFVF_TEX1 Or D3DFVF_DIFFUSE Or D3DFVF_SPECULAR
Private Moteur_Path As String

Private MainFont As D3DXFont, MainFontDesc As IFont, TextRect As RECT, fnt As New StdFont
Private FPSFont As D3DXFont, FPSFontDesc As IFont, FPSTextRect As RECT, FPSfnt As New StdFont
Private LastTimeCheckFPS As Long, FramesDrawn As Long, FrameRate As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long

Private DMPerf As DirectMusicPerformance8
Private DMLoader As DirectMusicLoader8
Private DMSegMidi() As DirectMusicSegment8
Private DMParam As DMUS_AUDIOPARAMS

Private DS As DirectSound8
Private DSBuffer() As DirectSoundSecondaryBuffer8
Private DSBDesc As DSBUFFERDESC

Private DI As DirectInput8
Private DIDevice As DirectInputDevice8
Private DIState As DIKEYBOARDSTATE
Private KeyState(0 To 255) As Boolean
Private Const BufferSize As Long = 10
Private aKeys(0 To 255) As String

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Timer1 As Long, Timer1State As Integer, Timer2 As Long
Private CurrentFrame As Integer

Private Type VERTEX
    X As Single
    Y As Single
    Z As Single
    rhw As Single
    color As Single
    specular As Single
    TU As Single
    TV As Single
End Type

Private Type Surface
    Texture As Long
    Hauteur As Long
    Largeur As Long
End Type

Private Type Sprite
    SHauteur As Long
    SLargeur As Long
    SNbreTileX As Long
    SNbreTileY As Long
    SSprite As D3DXSprite
    STexture As Long
End Type

Private Type Tempo
    Valeur As Long
    Count As Long
End Type

Private Col_Tempos(2048) As Tempo
Private Col_Surfaces(2048) As Surface
Private Col_Sprites(2048) As Sprite
Private Col_Textures() As Direct3DTexture8

Public Function Init_PleinEcran(ByVal Resolution_X As Long, ByVal Resolution_Y As Long, ByVal Bits_Couleurs As Long, ByVal Feuille_Handler As Long) As Boolean
On Error GoTo ErrInit_PleinEcran
ResoX = Resolution_X
ResoY = Resolution_Y
Handler = Feuille_Handler
Set D3D = DX.Direct3DCreate()
D3DParam.BackBufferCount = 1
If Bits_Couleurs = 32 Then
    D3DParam.BackBufferFormat = D3DFMT_A8R8G8B8
Else
    D3DParam.BackBufferFormat = D3DFMT_R5G6B5
End If
D3DParam.BackBufferHeight = ResoY
D3DParam.BackBufferWidth = ResoX
D3DParam.hDeviceWindow = Handler
D3DParam.SwapEffect = D3DSWAPEFFECT_COPY_VSYNC
D3DParam.Windowed = False
D3DParam.FullScreen_PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE
D3DParam.AutoDepthStencilFormat = D3DFMT_D16
D3DParam.EnableAutoDepthStencil = 1

Set D3DDevice = D3D.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, Handler, D3DCREATE_HARDWARE_VERTEXPROCESSING, D3DParam)
D3DDevice.SetVertexShader D3DFVF
D3DDevice.SetRenderState D3DRS_LIGHTING, False
D3DDevice.SetRenderState D3DRS_SPECULARENABLE, True
D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, True
D3DDevice.SetTextureStageState 0, D3DTSS_ALPHAOP, D3DTOP_MODULATE
D3DDevice.SetTextureStageState 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE
D3DDevice.SetTextureStageState 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE

FPSfnt.Name = "Verdana"
FPSfnt.Size = 8
FPSfnt.Bold = False
Set FPSFontDesc = FPSfnt
Set FPSFont = D3DX.CreateFont(D3DDevice, FPSFontDesc.hFont)
FPSTextRect.Top = 0
FPSTextRect.Left = 0
FPSTextRect.bottom = 15
FPSTextRect.Right = 200

Set DMPerf = DX.DirectMusicPerformanceCreate
Set DMLoader = DX.DirectMusicLoaderCreate
DMPerf.InitAudio Handler, DMUS_AUDIOF_ALL, DMParam, Nothing, DMUS_APATH_DYNAMIC_STEREO, 128
DMPerf.SetMasterAutoDownload True
DMPerf.AddNotificationType DMUS_NOTIFY_ON_SEGMENT
DMPerf.SetMasterTempo 1

Set DS = DX.DirectSoundCreate("")
DS.SetCooperativeLevel Handler, DSSCL_NORMAL
DSBDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME

Set DI = DX.DirectInputCreate
Set DIDevice = DI.CreateDevice("GUID_SysKeyboard")
DIDevice.SetCommonDataFormat DIFORMAT_KEYBOARD
DIDevice.SetCooperativeLevel Handler, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
DIDevice.Acquire

aKeys(1) = "Touche_Echap"
aKeys(2) = "Touche_1"
aKeys(3) = "Touche_2"
aKeys(4) = "Touche_3"
aKeys(5) = "Touche_4"
aKeys(6) = "Touche_5"
aKeys(7) = "Touche_6"
aKeys(8) = "Touche_7"
aKeys(9) = "Touche_8"
aKeys(10) = "Touche_9"
aKeys(11) = "Touche_10"
aKeys(12) = "Touche_-"
aKeys(13) = "Touche_="
aKeys(14) = "Touche_Retour"
aKeys(15) = "Touche_TAB"
aKeys(16) = "Touche_A"
aKeys(17) = "Touche_Z"
aKeys(18) = "Touche_E"
aKeys(19) = "Touche_R"
aKeys(20) = "Touche_T"
aKeys(21) = "Touche_Y"
aKeys(22) = "Touche_U"
aKeys(23) = "Touche_I"
aKeys(24) = "Touche_O"
aKeys(25) = "Touche_P"
aKeys(26) = "Touche_["
aKeys(27) = "Touche_]"
aKeys(28) = "Touche_Entrer"
aKeys(29) = "Touche_CtrlG"
aKeys(30) = "Touche_Q"
aKeys(31) = "Touche_S"
aKeys(32) = "Touche_D"
aKeys(33) = "Touche_F"
aKeys(34) = "Touche_G"
aKeys(35) = "Touche_H"
aKeys(36) = "Touche_J"
aKeys(37) = "Touche_K"
aKeys(38) = "Touche_L"
aKeys(39) = "Touche_SEMICOLON"
aKeys(40) = "Touche_APOSTROPHE"
aKeys(41) = "Touche_AccentGrave"
aKeys(42) = "Touche_ChiftG"
aKeys(43) = "Touche_BACKSLASH"
aKeys(44) = "Touche_Z"
aKeys(45) = "Touche_W"
aKeys(46) = "Touche_C"
aKeys(47) = "Touche_V"
aKeys(48) = "Touche_B"
aKeys(49) = "Touche_N"
aKeys(50) = "Touche_M"
aKeys(51) = "Touche_COMMA"
aKeys(52) = "Touche_PERIOD"
aKeys(53) = "Touche_SLASH"
aKeys(54) = "Touche_ChiftD"
aKeys(55) = "Touche_Multiplier"
aKeys(56) = "Touche_ALTG"
aKeys(57) = "Touche_Espace"
aKeys(58) = "Touche_CAPSLOCK"
aKeys(59) = "Touche_F1"
aKeys(60) = "Touche_F2"
aKeys(61) = "Touche_F3"
aKeys(62) = "Touche_F4"
aKeys(63) = "Touche_F5"
aKeys(64) = "Touche_F6"
aKeys(65) = "Touche_F7"
aKeys(66) = "Touche_F8"
aKeys(67) = "Touche_F9"
aKeys(68) = "Touche_F10"
aKeys(69) = "Touche_NUMLOCK"
aKeys(70) = "Touche_SCROLLLOCK"
aKeys(71) = "Touche_NUMPAD7"
aKeys(72) = "Touche_NUMPAD8"
aKeys(73) = "Touche_NUMPAD9"
aKeys(74) = "Touche_NUMPAD-"
aKeys(75) = "Touche_NUMPAD4"
aKeys(76) = "Touche_NUMPAD5"
aKeys(77) = "Touche_NUMPAD6"
aKeys(78) = "Touche_NUMPAD+"
aKeys(79) = "Touche_NUMPAD1"
aKeys(80) = "Touche_NUMPAD2"
aKeys(81) = "Touche_NUMPAD3"
aKeys(82) = "Touche_NUMPAD0"
aKeys(83) = "Touche_NUMPAD."
aKeys(87) = "Touche_F11"
aKeys(88) = "Touche_F12"
aKeys(86) = "Touche_F13"
aKeys(84) = "Touche_F14"
aKeys(85) = "Touche_F15"
aKeys(156) = "Touche_NUMPADENTER"
aKeys(157) = "Touche_CtrlD"
aKeys(91) = "Touche_NUMPADCOMMA"
aKeys(181) = "Touche_NUMPAD/"
aKeys(183) = "Touche_SYSRQ"
aKeys(184) = "Touche_AltD"
aKeys(199) = "Touche_HOME"
aKeys(200) = "Touche_HAUT"
aKeys(201) = "Touche_PageHaut"
aKeys(203) = "Touche_GAUCHE"
aKeys(205) = "Touche_DROITE"
aKeys(207) = "Touche_END"
aKeys(208) = "Touche_BAS"
aKeys(209) = "Touche_NEXT"
aKeys(210) = "Touche_INSERT"
aKeys(211) = "Touche_DELETE"
aKeys(219) = "Touche_WindowsG"
aKeys(220) = "Touche_WindowsD"
aKeys(221) = "Touche_APPS"
aKeys(116) = "Touche_PAUSE"

Init_PleinEcran = True

Exit Function
ErrInit_PleinEcran:
Init_PleinEcran = False
End Function

Public Function Init_Fenetre(ByVal Feuille_Handler As Long, ByVal Resolution_X As Long, ByVal Resolution_Y As Long) As Boolean
On Error GoTo errFenetre
ResoX = Resolution_X
ResoY = Resolution_Y
Handler = Feuille_Handler

Set DX = New DirectX8
Set D3D = DX.Direct3DCreate()
D3D.GetAdapterDisplayMode D3DADAPTER_DEFAULT, DispMode

D3DParam.BackBufferHeight = ResoY
D3DParam.BackBufferWidth = ResoX
D3DParam.Windowed = 1
D3DParam.SwapEffect = D3DSWAPEFFECT_COPY_VSYNC
D3DParam.BackBufferFormat = DispMode.Format
D3DParam.AutoDepthStencilFormat = D3DFMT_D16
D3DParam.EnableAutoDepthStencil = 1

Set D3DDevice = D3D.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, Handler, D3DCREATE_SOFTWARE_VERTEXPROCESSING, D3DParam)

D3DDevice.SetVertexShader D3DFVF
D3DDevice.SetRenderState D3DRS_LIGHTING, False
D3DDevice.SetRenderState D3DRS_SPECULARENABLE, True
D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, True
D3DDevice.SetTextureStageState 0, D3DTSS_ALPHAOP, D3DTOP_MODULATE
D3DDevice.SetTextureStageState 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE
D3DDevice.SetTextureStageState 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE

FPSfnt.Name = "Verdana"
FPSfnt.Size = 8
FPSfnt.Bold = False
Set FPSFontDesc = FPSfnt
Set FPSFont = D3DX.CreateFont(D3DDevice, FPSFontDesc.hFont)
FPSTextRect.Top = 0
FPSTextRect.Left = 0
FPSTextRect.bottom = 15
FPSTextRect.Right = 200

Set DMPerf = DX.DirectMusicPerformanceCreate
Set DMLoader = DX.DirectMusicLoaderCreate
DMPerf.InitAudio Handler, DMUS_AUDIOF_ALL, DMParam, Nothing, DMUS_APATH_DYNAMIC_STEREO, 128
DMPerf.SetMasterAutoDownload True
DMPerf.AddNotificationType DMUS_NOTIFY_ON_SEGMENT
DMPerf.SetMasterTempo 1

Set DS = DX.DirectSoundCreate("")
DS.SetCooperativeLevel Handler, DSSCL_NORMAL
DSBDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME

Set DI = DX.DirectInputCreate
Set DIDevice = DI.CreateDevice("GUID_SysKeyboard")
DIDevice.SetCommonDataFormat DIFORMAT_KEYBOARD
DIDevice.SetCooperativeLevel Handler, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
DIDevice.Acquire

aKeys(1) = "Touche_Echap"
aKeys(2) = "Touche_1"
aKeys(3) = "Touche_2"
aKeys(4) = "Touche_3"
aKeys(5) = "Touche_4"
aKeys(6) = "Touche_5"
aKeys(7) = "Touche_6"
aKeys(8) = "Touche_7"
aKeys(9) = "Touche_8"
aKeys(10) = "Touche_9"
aKeys(11) = "Touche_10"
aKeys(12) = "Touche_-"
aKeys(13) = "Touche_="
aKeys(14) = "Touche_Retour"
aKeys(15) = "Touche_TAB"
aKeys(16) = "Touche_A"
aKeys(17) = "Touche_Z"
aKeys(18) = "Touche_E"
aKeys(19) = "Touche_R"
aKeys(20) = "Touche_T"
aKeys(21) = "Touche_Y"
aKeys(22) = "Touche_U"
aKeys(23) = "Touche_I"
aKeys(24) = "Touche_O"
aKeys(25) = "Touche_P"
aKeys(26) = "Touche_["
aKeys(27) = "Touche_]"
aKeys(28) = "Touche_Entrer"
aKeys(29) = "Touche_CtrlG"
aKeys(30) = "Touche_Q"
aKeys(31) = "Touche_S"
aKeys(32) = "Touche_D"
aKeys(33) = "Touche_F"
aKeys(34) = "Touche_G"
aKeys(35) = "Touche_H"
aKeys(36) = "Touche_J"
aKeys(37) = "Touche_K"
aKeys(38) = "Touche_L"
aKeys(39) = "Touche_SEMICOLON"
aKeys(40) = "Touche_APOSTROPHE"
aKeys(41) = "Touche_AccentGrave"
aKeys(42) = "Touche_ChiftG"
aKeys(43) = "Touche_BACKSLASH"
aKeys(44) = "Touche_Z"
aKeys(45) = "Touche_W"
aKeys(46) = "Touche_C"
aKeys(47) = "Touche_V"
aKeys(48) = "Touche_B"
aKeys(49) = "Touche_N"
aKeys(50) = "Touche_M"
aKeys(51) = "Touche_COMMA"
aKeys(52) = "Touche_PERIOD"
aKeys(53) = "Touche_SLASH"
aKeys(54) = "Touche_ChiftD"
aKeys(55) = "Touche_Multiplier"
aKeys(56) = "Touche_ALTG"
aKeys(57) = "Touche_Espace"
aKeys(58) = "Touche_CAPSLOCK"
aKeys(59) = "Touche_F1"
aKeys(60) = "Touche_F2"
aKeys(61) = "Touche_F3"
aKeys(62) = "Touche_F4"
aKeys(63) = "Touche_F5"
aKeys(64) = "Touche_F6"
aKeys(65) = "Touche_F7"
aKeys(66) = "Touche_F8"
aKeys(67) = "Touche_F9"
aKeys(68) = "Touche_F10"
aKeys(69) = "Touche_NUMLOCK"
aKeys(70) = "Touche_SCROLLLOCK"
aKeys(71) = "Touche_NUMPAD7"
aKeys(72) = "Touche_NUMPAD8"
aKeys(73) = "Touche_NUMPAD9"
aKeys(74) = "Touche_NUMPAD-"
aKeys(75) = "Touche_NUMPAD4"
aKeys(76) = "Touche_NUMPAD5"
aKeys(77) = "Touche_NUMPAD6"
aKeys(78) = "Touche_NUMPAD+"
aKeys(79) = "Touche_NUMPAD1"
aKeys(80) = "Touche_NUMPAD2"
aKeys(81) = "Touche_NUMPAD3"
aKeys(82) = "Touche_NUMPAD0"
aKeys(83) = "Touche_NUMPAD."
aKeys(87) = "Touche_F11"
aKeys(88) = "Touche_F12"
aKeys(86) = "Touche_F13"
aKeys(84) = "Touche_F14"
aKeys(85) = "Touche_F15"
aKeys(156) = "Touche_NUMPADENTER"
aKeys(157) = "Touche_CtrlD"
aKeys(91) = "Touche_NUMPADCOMMA"
aKeys(181) = "Touche_NUMPAD/"
aKeys(183) = "Touche_SYSRQ"
aKeys(184) = "Touche_AltD"
aKeys(199) = "Touche_HOME"
aKeys(200) = "Touche_HAUT"
aKeys(201) = "Touche_PageHaut"
aKeys(203) = "Touche_GAUCHE"
aKeys(205) = "Touche_DROITE"
aKeys(207) = "Touche_END"
aKeys(208) = "Touche_BAS"
aKeys(209) = "Touche_NEXT"
aKeys(210) = "Touche_INSERT"
aKeys(211) = "Touche_DELETE"
aKeys(219) = "Touche_WindowsG"
aKeys(220) = "Touche_WindowsD"
aKeys(221) = "Touche_APPS"
aKeys(116) = "Touche_PAUSE"

Init_Fenetre = True
errFenetre:
Init_Fenetre = False
End Function

Public Sub Init_Path(Chemin As String)
Moteur_Path = Chemin
End Sub

Public Sub Debut_Scene()
On Error Resume Next
DoEvents
D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, RGB(0, 0, 0), 1#, 0
D3DDevice.BeginScene
End Sub

Public Sub Fin_Scene()
On Error Resume Next

If GetTickCount - LastTimeCheckFPS >= 1000 Then
    LastTimeCheckFPS = GetTickCount
    FrameRate = FramesDrawn
    FramesDrawn = 0
End If
FramesDrawn = FramesDrawn + 1&

If Afficher_FPS = True Then
    D3DX.DrawText FPSFont, &HFFFF0000, "Framerate : " & FrameRate, FPSTextRect, DT_LEFT
End If

D3DDevice.EndScene
D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub

Public Sub FIN()
On Error Resume Next
DUKE_Running = False
DIDevice.Unacquire
Set D3DDevice = Nothing
Set D3D = Nothing
Set DX = Nothing
Set D3DX = Nothing
Set DS = Nothing
Set DMPerf = Nothing
Set DI = Nothing
Set DIDevice = Nothing
Erase Col_Textures
Erase Col_Surfaces
Erase Col_Sprites
Erase Col_Tempos
Erase DSBuffer
Erase DMSegMidi
End
End Sub

Public Function Charger_TextureList(ByVal Url_Liste As String) As Boolean
On Error GoTo errTextures
Dim tmpString As String
Dim I As Integer
Dim fFile As Integer
Dim tmpTab() As String
Dim tmpColorKey As Long
fFile = FreeFile
Open Url_Liste For Input As #fFile
Line Input #fFile, tmpString
ReDim Col_Textures(Val(tmpString)) As Direct3DTexture8
Set Col_Textures(0) = Nothing
For I = 1 To Val(tmpString)
    Line Input #fFile, tmpString
    tmpTab = Split(tmpString, ",", , vbTextCompare)
    If tmpTab(1) = "" Then
        Set Col_Textures(I) = D3DX.CreateTextureFromFile(D3DDevice, Moteur_Path & "\" & tmpTab(0))
        DoEvents
    Else
        tmpColorKey = Creer_CouleurCle(CLng(tmpTab(1)), CLng(tmpTab(2)), CLng(tmpTab(3)), CLng(tmpTab(4)))
        Set Col_Textures(I) = D3DX.CreateTextureFromFileEx(D3DDevice, Moteur_Path & "\" & tmpTab(0), D3DX_DEFAULT, D3DX_DEFAULT, 1&, 0&, D3DFMT_UNKNOWN, D3DPOOL_MANAGED, D3DX_FILTER_NONE, D3DX_FILTER_POINT, tmpColorKey, ByVal 0, ByVal 0)
        DoEvents
    End If
Next I
Close #fFile
Charger_TextureList = True
Exit Function
errTextures:
Charger_TextureList = False
End Function

Public Function Charger_MidiList(ByVal Url_Liste As String) As Boolean
On Error GoTo errMidi
Dim tmpString As String
Dim I As Integer
Dim fFile As Integer
fFile = FreeFile
Open Url_Liste For Input As #fFile
Line Input #fFile, tmpString
ReDim DMSegMidi(Val(tmpString)) As DirectMusicSegment8
Set DMSegMidi(0) = Nothing
For I = 1 To Val(tmpString)
    Line Input #fFile, tmpString
    Set DMSegMidi(I) = DMLoader.LoadSegment(Moteur_Path & "\" & tmpString)
    DMSegMidi(I).SetStandardMidiFile
    DoEvents
Next I
Close #fFile
Charger_MidiList = True
Exit Function
errMidi:
Charger_MidiList = False
End Function

Public Function Charger_WavList(ByVal Url_Liste As String) As Boolean
On Error GoTo errWav
Dim tmpString As String
Dim I As Integer
Dim fFile As Integer
fFile = FreeFile
Open Url_Liste For Input As #fFile
Line Input #fFile, tmpString
ReDim DSBuffer(Val(tmpString)) As DirectSoundSecondaryBuffer8
Set DSBuffer(0) = Nothing
For I = 1 To Val(tmpString)
    Line Input #fFile, tmpString
    Set DSBuffer(I) = DS.CreateSoundBufferFromFile(Moteur_Path & "\" & tmpString, DSBDesc)
    DoEvents
Next I
Close #fFile
Charger_WavList = True
Exit Function
errWav:
Charger_WavList = False
End Function

Public Sub Jouer_Midi(ByVal ID_Midi As Long, ByVal JouerEnBoucle As Boolean)
If JouerEnBoucle = True Then
    DMSegMidi(ID_Midi).SetRepeats -1
Else
    DMSegMidi(ID_Midi).SetRepeats 0
End If
DMPerf.PlaySegmentEx DMSegMidi(ID_Midi), DMUS_SEGF_DEFAULT, 0
End Sub

Public Sub Stop_Midi(ByVal ID_Midi As Long)
DMPerf.StopEx DMSegMidi(ID_Midi), 0, DMUS_SEGF_DEFAULT
End Sub

Public Sub Jouer_Wav(ID_Wav As Long, JouerEnBoucle As Boolean)
Stop_Wav ID_Wav
If JouerEnBoucle = True Then
  DSBuffer(ID_Wav).Play DSBPLAY_LOOPING
Else
  DSBuffer(ID_Wav).Play DSBPLAY_DEFAULT
End If
End Sub

Private Sub Stop_Wav(ID_Wav As Long)
DSBuffer(ID_Wav).Stop
DSBuffer(ID_Wav).SetCurrentPosition 0
End Sub

Public Sub Creer_Surface(ByVal ID_Surface As Long, ByVal ID_Texture As Long, ByVal Hauteur As Long, ByVal Largeur As Long)
Col_Surfaces(ID_Surface).Hauteur = Hauteur
Col_Surfaces(ID_Surface).Largeur = Largeur
Col_Surfaces(ID_Surface).Texture = ID_Texture
End Sub

Public Sub Afficher_Surface(ByVal ID_Surface As Long, PosX As Long, PosY As Long)
Dim Couleur As Long
Dim tmpVertex(3) As VERTEX
Couleur = D3DColorARGB(128, 128, 128, 128)
tmpVertex(0) = CreateTLVertex(PosX, PosY, 0&, 1&, Couleur, 0&, 0&, 0&)
tmpVertex(1) = CreateTLVertex(PosX + Col_Surfaces(ID_Surface).Largeur, PosY, 0&, 1&, Couleur, 0&, 1&, 0&)
tmpVertex(2) = CreateTLVertex(PosX, PosY + Col_Surfaces(ID_Surface).Hauteur, 0&, 1&, Couleur, 0&, 0&, 1&)
tmpVertex(3) = CreateTLVertex(PosX + Col_Surfaces(ID_Surface).Largeur, PosY + Col_Surfaces(ID_Surface).Hauteur, 0&, 1&, Couleur, 0&, 1&, 1&)
D3DDevice.SetTexture 0, Col_Textures(Col_Surfaces(ID_Surface).Texture)
D3DDevice.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2&, tmpVertex(0), Len(tmpVertex(0))
End Sub

Private Function Creer_CouleurCle(ByVal Rouge As Single, ByVal Vert As Single, ByVal Bleu As Single, ByVal Alpha As Single) As Long
Creer_CouleurCle = D3DColorMake(Rouge, Vert, Bleu, Alpha)
End Function

Public Sub Creer_Timer(ByVal ID_Timer As Long)
Col_Tempos(ID_Timer).Valeur = 0
Col_Tempos(ID_Timer).Count = 0
End Sub

Public Sub Incrementer_Timer(ID_Timer As Long)
If GetTickCount - Col_Tempos(ID_Timer).Count > 0 Then
    Col_Tempos(ID_Timer).Valeur = Col_Tempos(ID_Timer).Valeur + (GetTickCount - Col_Tempos(ID_Timer).Count)
    Col_Tempos(ID_Timer).Count = GetTickCount
End If
End Sub

Public Sub Reinitialiser_Timer(ID_Timer As Long)
Col_Tempos(ID_Timer).Valeur = 0
End Sub

Public Function Valeur_Timer(ID_Timer As Long) As Long
Valeur_Timer = Col_Tempos(ID_Timer).Valeur
End Function

Public Sub Creer_Sprite(ByVal ID_Sprite As Long, ByVal ID_Texture As Long, ByVal Hauteur As Long, ByVal Largeur As Long, ByVal NbreTileX As Long, ByVal NbreTileY As Long)
NbreTileX = NbreTileX - 1
NbreTileY = NbreTileY - 1
Col_Sprites(ID_Sprite).STexture = ID_Texture
Col_Sprites(ID_Sprite).SHauteur = Hauteur
Col_Sprites(ID_Sprite).SLargeur = Largeur
Col_Sprites(ID_Sprite).SNbreTileX = NbreTileX
Col_Sprites(ID_Sprite).SNbreTileY = NbreTileY
Set Col_Sprites(ID_Sprite).SSprite = D3DX.CreateSprite(D3DDevice)
End Sub

Public Sub Afficher_Sprite(ByVal ID_Sprite As Long, ByVal PosX As Long, ByVal PosY As Long, ByVal TileX As Long, ByVal TileY As Long, ByVal ScaleX As Single, ByVal ScaleY As Single, ByVal Angle As Single, ByVal Coul_ROUGE As Single, ByVal Coul_VERT As Single, ByVal Coul_BLEU As Single, ByVal Alpha As Single)
Dim Scaling As D3DVECTOR2
Dim Center As D3DVECTOR2
Dim Positions As D3DVECTOR2
Dim MonRect As RECT
TileX = TileX - 1
TileY = TileY - 1
Scaling.X = ScaleX
Scaling.Y = ScaleY
Positions.X = PosX
Positions.Y = PosY
Coul_ROUGE = Round(Coul_ROUGE / 255, 2)
Coul_VERT = Round(Coul_VERT / 255, 2)
Coul_BLEU = Round(Coul_BLEU / 255, 2)
Alpha = Alpha / 100
MonRect.Left = Col_Sprites(ID_Sprite).SLargeur * TileX
MonRect.Right = MonRect.Left + Col_Sprites(ID_Sprite).SLargeur
MonRect.Top = Col_Sprites(ID_Sprite).SHauteur * TileY
MonRect.bottom = MonRect.Top + Col_Sprites(ID_Sprite).SHauteur
Col_Sprites(ID_Sprite).SSprite.Begin
Col_Sprites(ID_Sprite).SSprite.Draw Col_Textures(Col_Sprites(ID_Sprite).STexture), MonRect, Scaling, Center, Angle, Positions, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha)
Col_Sprites(ID_Sprite).SSprite.End
End Sub

Public Sub Init_Font(ByVal Police As String, ByVal Taille As Long, ByVal Gras As Boolean, ByVal Italique As Boolean, ByVal Souligne As Boolean)
fnt.Name = Police
fnt.Size = Taille
fnt.Bold = Gras
fnt.Italic = Italique
fnt.Underline = Souligne
Set MainFontDesc = fnt
Set MainFont = D3DX.CreateFont(D3DDevice, MainFontDesc.hFont)
End Sub

Public Sub Afficher_Texte(ByVal Texte As String, ByVal Coul_ROUGE As Long, ByVal Coul_VERT As Long, ByVal Coul_BLEU As Long, ByVal Alpha As Long, ByVal Alignement As Integer, ByVal Haut As Long, ByVal Bas As Long, ByVal Gauche As Long, ByVal Droite As Long)
TextRect.Top = Haut
TextRect.Left = Gauche
TextRect.bottom = Bas
TextRect.Right = Droite
Coul_ROUGE = Round(Coul_ROUGE / 255, 2)
Coul_VERT = Round(Coul_VERT / 255, 2)
Coul_BLEU = Round(Coul_BLEU / 255, 2)
Alpha = Alpha / 100
Select Case Alignement
    Case 0: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_LEFT
    Case 1: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_TOP
    Case 2: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_CENTER
    Case 3: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_RIGHT
    Case 4: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_VCENTER
    Case 5: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_BOTTOM
    Case 6: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_BOTTOM Or DT_CENTER
    Case 7: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_BOTTOM Or DT_RIGHT
    Case 8: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_TOP Or DT_CENTER
    Case 9: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_TOP Or DT_RIGHT
    Case 10: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_VCENTER Or DT_CENTER
    Case 11: D3DX.DrawText MainFont, Creer_CouleurCle(Coul_ROUGE, Coul_VERT, Coul_BLEU, Alpha), Texte, TextRect, DT_VCENTER Or DT_RIGHT
End Select
End Sub

Public Sub Afficher_Triangle(ByVal PosX As Long, ByVal PosY As Long, ByVal Hauteur As Long, ByVal Largeur As Long, ByVal Couleur As Long)
Dim tmpVertex(3) As VERTEX
tmpVertex(0) = CreateTLVertex(PosX, PosY, 0&, 1&, Couleur, 0&, 0&, 0&)
tmpVertex(1) = CreateTLVertex(PosX + Largeur, PosY, 0&, 1&, Couleur, 0&, 1&, 0&)
tmpVertex(2) = CreateTLVertex(PosX, PosY + Hauteur, 0&, 1&, Couleur, 0&, 0&, 1&)
tmpVertex(3) = CreateTLVertex(PosX + Largeur, PosY + Hauteur, 0&, 1&, Couleur, 0&, 1&, 1&)
D3DDevice.SetTexture 0, Nothing
D3DDevice.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2&, tmpVertex(0), Len(tmpVertex(0))
End Sub

Private Function CreateTLVertex(ByVal X As Long, ByVal Y As Long, ByVal Z As Long, ByVal rhw As Long, ByVal color As Long, ByVal specular As Long, ByVal TU As Long, ByVal TV As Long) As VERTEX
CreateTLVertex.X = X
CreateTLVertex.Y = Y
CreateTLVertex.Z = Z
CreateTLVertex.rhw = rhw
CreateTLVertex.color = color
CreateTLVertex.specular = specular
CreateTLVertex.TU = TU
CreateTLVertex.TV = TV
End Function

Public Function Acquerir_Clavier() As String
Dim I As Integer
DIDevice.GetDeviceStateKeyboard DIState
For I = 0 To 255
    If DIState.Key(I) = 128 Then
        Acquerir_Clavier = KeyNames(I)
    End If
Next I
End Function
Function KeyNames(Num As Integer) As String
KeyNames = aKeys(Num)
End Function

